/* Action.h -*- c++ -*- Hans-Peter Stoerr Thu Feb  4 1999 */

#ifndef _ACTION_H
#define _ACTION_H

#include <ostream>
#include <iterator.h>
using namespace std;

#include "Printable.h"
#include "Substitution.h"
#include "pddldomain.h"

class Domain;

typedef vector<string> StringVector;

class Action : public Printable 
{
public:
  string        mName;
  Substitution  mSubst;
  PddlAction const*     mpRep;
  
  bool operator==(const Action& b) const { return b.mName==mName && b.mSubst==mSubst; }
  string        Description() const;
protected:
  virtual void  Printit(ostream&) const;
};

class ActionIterator : public Object, public input_iterator<Action,void>
{
public:
  ActionIterator();             // yields end iterator
  ActionIterator(Domain&);      // yields begin iterator
  // ActionIterator(const ActionIterator&); // use compiler generated
  // ActionIterator& operator=(const ActionIterator&); // use compiler generated
  virtual       ~ActionIterator();

  bool operator==(const ActionIterator&) const;
  bool operator!=(const ActionIterator&) const;
  
  const Action& operator *() { return mAction; }
  const Action* operator ->() { return &mAction; }
  ActionIterator& operator++();
  // ActionIterator operator++(int) { ActionIterator res(*this); ++(*this); return res; }
  
protected:
  Action        mAction;        // the action we have now
  StringPddlActionMap::const_iterator mActIter,mActEnd;
  // iterators for the objects of each argument
  vector<StringVector::const_iterator>  mBeginIters,mIters,mEndIters;
  StringVector  mVarNames;
  Domain*       mpDom;           // the domain we are working on.

  bool  NextAction(bool firsttime=FALSE); // goes to the next actionname.
};

#endif
