/* BddTransPlan.h -*- c++ -*- Hans-Peter Stoerr Wed Feb  3 1999 */

#ifndef _BddTRANSPLAN_H
#define _BddTRANSPLAN_H

#include "objcal.h"

#include "Printable.h"
#include "Domain.h"
#include "DisjPartBdd.h"

class BddTransPlan : public Printable
{
public:
  BddTransPlan(Domain& theDom) : mDom(theDom) {}
  virtual ~BddTransPlan() {}

  StringVector  mPlan;

  void  Run();
protected:
  Domain& mDom;
  Bdd   mInit;
  DisjPartBdd   mTrans;
  Bdd   mFilter;                // works as a filter of possible states.
  Bdd   mGoal;
  map<string,pair<Bdd,BddVector> >       mActionBdds;

  void  Init();

  virtual void Printit(ostream& s) const;
  void  ForwardPass();
  void  BackwardPass();

  BddVector     forward;
  BddVector     backward;

private:
  BddTransPlan(const BddTransPlan&); // unimplemented, can't be done.
  BddTransPlan& operator =(const BddTransPlan&); // unimplemented, can't be done.

  void  GenerateTransRel();
  void  ReduceActionSet();      // remove irrelevant actions

  Bdd   PrimedToUnprimed(Bdd) const; // faster replacement for Substitute(mgr.Prim...)
  Bdd   UnprimedToPrimed(Bdd) const; // faster replacement for Substitute(mgr.Unprim...)
};

#endif
