/* DisjPartBdd.h -*- c++ -*- Hans-Peter Stoerr Sun Feb  7 1999 */
// disjunctive partitioned BDD

#ifndef _DISJPARTBDD_H
#define _DISJPARTBDD_H

#include "objcal.h"
#include "Printable.h"
#include <vector>
#include <ostream>
using namespace std;

class DisjPartBddConstructor;   // for internal use.

class DisjPartBdd : public Printable
// this has to be constructed with +=, then Finish()ed, and then used.
{
  friend class DisjPartBddConstructor;
public:
  DisjPartBdd();
  virtual ~DisjPartBdd();

  // assigns a new part. The part consists of a Bdd as well as the set of its important fluents as a hint.
  DisjPartBdd& operator +=(pair<Bdd,BddVector>);
  void  Finish(Bdd reduce); // tells the DisjPartBdd that it now contains all parts.
  // reduce Bdds through mult with redBdd and existential quantification
  void  Reduce(Bdd redBdd,const BddAssoc& redAss);
  
  // DisjPartBdd&  operator=(const DisjPartBdd& b) { mBddVector=b.mBddVector; ... ; return *this; }
  
  Bdd   operator*(Bdd) const;
  Bdd   RelProd(const BddAssoc&,Bdd,double maxtime=1e6) const;
  Bdd   Exists(const BddAssoc&) const;
  bool  Intersects(Bdd) const;  // returns true if *this*parm != mgr.Zero()
protected:
  BddVector     mBddVector;
  DisjPartBddConstructor *mConstruct; // used while constructing this.

  virtual void  Printit(std::ostream&) const;
private:
  DisjPartBdd(const DisjPartBdd&); // not allowed
  DisjPartBdd& operator+(const DisjPartBdd&); // not allowed
};

#endif
