/* Options.h -*- c++ -*- Hans-Peter Stoerr Mon Feb  8 1999 */
// Object that memorizes all execution options given for running the program

#ifndef _OPTIONS_H
#define _OPTIONS_H

#include <ostream>
using namespace std;

void    SetOption(const char* name,int value=1); // set option
// set ',' separated options, values given with '='
void    SetOptions(const char*);
void    PrintOptions();         // print Options
void    DescribeOptions(bool called=0);      // give description of all options to cerr or cout if called.

class   Option
// declares an option.
{
public:
  Option(const char* thename, const char* description, int defaultvalue=0);
  operator int();               // query option.
  Option& operator=(int val) { SetOption(name,val); return *this; }

protected:
  const char* name;
};

class   DependentOption : public Option
// option that depends on another option.
{
public:
  DependentOption(const char* thename, const char* depends_on, const char* description, int defaultvalue=0);
};

#endif
