// Hey Emacs! This is -*- c++ -*- ! :-)
// stltest.cc	-- Hans-Peter Stoerr Tue Jan 12 1999
//
// $Id: stltest.cc,v 2.1 2000/02/14 16:20:28 stoerr Exp $
//
// $Log: stltest.cc,v $
// Revision 2.1  2000/02/14 16:20:28  stoerr
// Now starting major restructuring of action generation.
//
// Revision 1.3  1999/02/23 21:16:25  stoerr
// .
//
// Revision 1.2  1999/02/16 17:17:31  stoerr
// .
//
// Revision 1.1  1999/02/08  14:09:01  stoerr
// everything works, basically.
//
//

#include <stdio.h>
#include <iostream.h>
#include <string>
#include <vector>
#include <stl.h>
#include <iterator.h>

typedef map<string, string, less<string> > StringStringMap;

typedef set<string,less<string> > StringSet;

#if sun
extern "C" long random();
#endif

#define PR(X) cout << #X << ":" << X << "\n";

void test1()
{
  list<int> l;
  l.push_front(4);
  l.push_back(3);
  l.push_front(1);
  copy(l.begin(),l.end(),ostream_iterator<int>(cout,"\n"));
}

void test2()
{
  StringStringMap mo,m(mo);
  m["bla"]="blu";
  m["hah"]="foobar";
  m["baz"]="bluf";
  for(StringStringMap::iterator it=m.begin(); it!=m.end(); ++it)
    cout << (*it).first << " : " << (*it).second << "\n";
}

template<class T> T clone(const T& t) { return t; }

class A 
{
public:
  A(){a=5;cout << "default constructor A\n";}
  A(const A&){a=7;cout << "copy constructor A\n";}
  ~A(){a=7;cout << "destructor A\n";}
  int a;
  static void atest()
  {
    A a;
    A b(a);
  }
  static void atest1()
  {
    A a;
    clone(a);
  }
};

class B : public A
{
public:
  static void btest()
  {
    B a;
    B b(a);
  }  
  static void btest1()
  {
    B a;
    clone(a);
  }
};

template <class T> T func(T bla)
{
  return bla;
}

void funcpointertest()
{
  binary_function<string,string,pair<string,string> > *p;
  // p=pointer_to_binary_function<string,string,pair<string,string> >(make_pair);
  int (*murks)(int);
  murks=func;
}

void setunion_test()
{
  StringSet s1,s2;
  s1.insert("bla"); s1.insert("blu"); s1.insert("bleu");
  s2.insert("req"); s2.insert("blu"); s2.insert("req");
  copy(s2.begin(),s2.end(),inserter(s1,s1.begin()));
  //set_union(s1.begin(),s1.end(),s2.begin(),s2.end(),inserter(s1,s1.begin()));
  copy(s1.begin(),s1.end(),ostream_iterator<string>(cout, "\n"));
}

string *downcasep(const char* const p)
{
  string *res=new string;
  transform(p,p+strlen(p),inserter(*res,res->end()),ptr_fun(tolower));
  return res;
}
// cout << *downcasep("BalbAlLa") << "\n";

void constpointers()
{
  int a;
  const int * const b =&a;
  // *b=5;                         // disallowed.
  // b=&a;                         // disallowed.
}

typedef vector<int> theset; // 1.91 union, 0.39 intersection, 1.15 difference
// typedef set<int,less<int> > theset; // 19.62 union, 3.03 intersection, 10.64 difference

void settest()
{
  int i;
  const int max=10000;
  theset a,b,c,empty;
  for(i=0;i<max;i++)
    if( (random()%50)==0 ) a.push_back(i);
  // if( (random()%50)==0 ) a.insert(i);
  for(i=0;i<max;i++)
    if( (random()%2)==0 ) b.push_back(i);
    // if( (random()%2)==0 ) b.insert(i);
  for(i=0;i<1000;i++) {
    c=empty;
    set_difference(a.begin(),a.end(),b.begin(),b.end(),
              back_inserter(c));
  }
//   copy(a.begin(),a.end(),ostream_iterator<int>(cout,","));
  cout << a.size() << "=a\t";
//   copy(b.begin(),b.end(),ostream_iterator<int>(cout,","));
  cout << b.size() << "=b\t";
//   copy(c.begin(),c.end(),ostream_iterator<int>(cout,","));
  cout << c.size() << "=c\n";
  cout << "Yep!\n";
}

template <class Result, class Arg> class Test
{
public:
  Result operator() (Arg t)
  {
    return Result(t);
  }
  Result operator() ()
  {
    return Result();
  }
};

class Test1: public Test<void,void>
{
};

typedef vector<string> StringVector;

#define DASSIGN(x,y) typeof((y)) x=(y)

class StrGen
{
public:
  StrGen() : s(new char[3]) {s[0]='a'; s[1]='a'; s[2]=0;}
  string operator() ()
  {
    string res(s);
    if (++s[1]>'z'){ s[1]='a'; ++s[0]; }
    return res;
  }
private:
  char *s;
};

void vectortest()
{
  StringVector vec,vec1;
  StrGen gen;
  // DASSIGN(iit,back_inserter(vec));
  DASSIGN(iit,inserter(vec,vec.begin()));
  generate_n(iit,50,gen);
  DASSIGN(nit,back_inserter(vec));
  generate_n(nit,200,gen);
  vec1.reserve(300);
  copy(vec.begin(),vec.end(),back_inserter(vec1));
  copy(vec1.begin(),vec1.end(),ostream_iterator<string>(cout,", "));
  cout << "\n";
  StringVector a,b(a),c;
  set_union(a.begin(),a.end(),b.begin(),b.end(),back_inserter(c));
  cout << "works.\n";
}

template<class T> 
class ST
{
public:
  static T smember;
  T     foo() { return smember; }
};

template<class T>
T ST<T>::smember;

template<class T>
foo(T) { return ST<T>::smember; }

#if 0  
  ST<int> bla;
  bla.foo();
  foo('a');
  ST<string>::smember=" ";
#endif

class t {
public:
  virtual ~t(){};
};
class ta : public t {} a;
class tb : public t {} b;

void    test(t *p)
{
  if (ta *a=dynamic_cast<ta*>(p))
    cout << "a\n";
  if (tb *b=dynamic_cast<tb*>(p))
    cout << "b\n";  
}

int main(int argc, char **argv)
{
  test(&a);
  test(&b);
  return 0;
}

