/* objcal_inline.h -*- c++ -*- Hans-Peter Stoerr Wed Feb  3 1999 */
// inline definitions for Bdd and BddRep

#ifndef _OBJCAL_INLINE_H
#define _OBJCAL_INLINE_H

// ================================================================
// inline definitions for BddRep.

inline BddMgr::operator Cal_BddManager() const { return theManager; }

inline Bdd::BddRep::BddRep()
{
  theBdd=NULL;
}

inline Bdd::BddRep::BddRep(const BddRep& b)
{
  if(b.theBdd) Cal_BddUnFree(mgr,theBdd);
  theBdd=b.theBdd;    
}
 
inline Bdd::BddRep& Bdd::BddRep::operator=(const Bdd::BddRep& b)
{
  if(b.theBdd) Cal_BddUnFree(mgr,b.theBdd);
  if(theBdd) Cal_BddFree(mgr,theBdd);
  theBdd=b.theBdd;
  return *this;
}

inline Bdd::BddRep::~BddRep()
{
  assert(mgr.Operative());
  if(theBdd) Cal_BddFree(mgr,theBdd);
}

// inline Bdd::BddRep::BddRep(const Cal_Bdd Bdd)
// {
//   theBdd=Bdd;
// }

inline Bdd::BddRep& Bdd::BddRep::operator=(const Cal_Bdd Bdd)
{
  if(theBdd) Cal_BddFree(mgr,theBdd);
  theBdd=Bdd;
  return *this;
}

inline Bdd::BddRep::operator Cal_Bdd() const
{
  return theBdd;
}

// ================================================================
// inline definitions for Bdd for fast parameter passing

inline Bdd::Bdd() {}

inline Bdd::Bdd(const Bdd& b)
{
  rep=b.rep;
}

inline Bdd::Bdd(const string s)
{
  *this=mgr.Var(s);
}

inline Bdd::~Bdd() {}

inline Bdd& Bdd::operator=(const Bdd& b)
{
  rep=b.rep;
  return *this;
}

inline Bdd::operator Cal_Bdd() const
{
  return Cal_Bdd(rep);
}

// ================================================================
// some more inlines

inline Bdd::Bdd(Cal_Bdd b)
{
  rep=b;
}

inline Bdd::Bdd(Cal_Bdd b,unfreeT)
{
  Cal_BddUnFree(mgr,b);
  rep=b;
}

// ================================================================
// inline Defs for BddAssocs

const BddAssoc&       BddMgr::Unprimed() { // set of unprimed vars
  if (!mAssocsValid) updateAssocs();
  return noprimed;
}
const BddAssoc&       BddMgr::Primed() { // set of primed vars
  if (!mAssocsValid) updateAssocs();
  return primed;
}
const BddAssoc&       BddMgr::UnprimedToPrimed() { // substitute unprimed to primed vars
  if (!mAssocsValid) updateAssocs();
  return noprimetoprime;
}
const BddAssoc&       BddMgr::PrimedToUnprimed() { // substitute primed vars to unprimed
  if (!mAssocsValid) updateAssocs();
  return primetonoprime;
}


#endif
